//+------------------------------------------------------------------+
//|                                                  liquidchart.mqh |
//|                                         Copyright 2014, Decanium |
//|                                          http://www.decanium.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, Decanium"
#property link      "http://www.decanium.com"
//+------------------------------------------------------------------+
//|                   |
//+------------------------------------------------------------------+
int GetRatesLC(int start_pos,int len,MqlRates &rates[],ENUM_TIMEFRAMES base_period,int &shift)
  {
//        
   int k=PeriodSeconds()/PeriodSeconds(base_period);
   if(k==0)
      return(-1);//   
   //---
   MqlRates r0[];
   ArrayResize(rates,len);
   if(CopyRates(_Symbol,_Period,start_pos,1,r0)<1)
      return(0);// 
   //---
   int sh;
   if(shift>=0)
     {// 
      if(shift<k)
         sh=shift;
      else
         return(-2);//     
     }
   else if(shift==-1)
     {//   (,   )
      sh=int((TimeCurrent()-r0[0].time)/PeriodSeconds(base_period));
     }
   else if(shift==-2)
     {//   (,   )
      sh=1+int((TimeCurrent()-r0[0].time)/PeriodSeconds(base_period));
      if(sh>=k)
         sh=0;
     }
   else
      return(-2);//         
   //---
   datetime tO;//    ,       
               //  tO     
   datetime tC;//   , ..        
   tO=r0[0].time+sh*PeriodSeconds(base_period);
   if(tO>TimeCurrent())
      tO-=PeriodSeconds();
   tC=tO+PeriodSeconds()-PeriodSeconds(base_period);
   if(tC>TimeCurrent())
      tC=TimeCurrent();
   int cnt=0;
   while(cnt<len)
     {
      ArrayFree(r0);
      int l=CopyRates(_Symbol,base_period,tC,k,r0);
      if(l<1)
         break;
      //    (l-1)    tC
      //    tC  ,     
      //  ,      tC
      tC=r0[l-1].time;
      //  ,  to   .    , .  
      while(tO>tC)
         tO-=PeriodSeconds();
      //  tO  tC         
      int index=len-1-cnt;
      rates[index].close=0;
      rates[index].open=0;
      rates[index].high=0;
      rates[index].low=0;
      rates[index].time=tO;
      for(int i=0; i<l; i++)
         if(r0[i].time>=tO && r0[i].time<=tC)
           {
            if(rates[index].open==0)
              {
               rates[index].open= r0[i].open;
               rates[index].low = r0[i].low;
               rates[index].high= r0[i].high;
              }
            else
              {
               if(rates[index].low>r0[i].low)
                  rates[index].low=r0[i].low;
               if(rates[index].high<r0[i].high)
                  rates[index].high=r0[i].high;
              }
            rates[index].close=r0[i].close;
           }
      //   ,   
      tC=tO-PeriodSeconds(base_period);
      cnt++;
     }
   if(cnt<len)
     {// ,  .    .
      int d=len-cnt;
      for(int j=0; j<cnt; j++)
         rates[j]=rates[j+d];
      for(int j=cnt;j<len;j++)
        {//     
         rates[j].close=0;
         rates[j].open=0;
         rates[j].high=0;
         rates[j].low=0;
         rates[j].time=0;
        }
     }
   shift=sh;
   return(cnt);
  }
//+------------------------------------------------------------------+
